# Clion配置Windows环境下基于WSL2的Docker容器工具链

## Docker新建容器

```powershell
docker pull centos:7 # 获取centos7的镜像
docker run -it -d --privileged=true --name centos -p 2222:22 centos:7 /usr/sbin/init # 启用内核权限 绑定容器ssh的22端口到主机的2222端口
docker exec -it centos bash # 进入容器
```

### 修改已有容器配置

查看容器的hash。

```powershell
docker container ls -a
```

Windows下wsl2的容器配置文件目录`\\wsl$\docker-desktop-data\version-pack-data\community\docker\containers\<hash_of_the_container>`。修改该目录下的配置文件。

## 容器内环境配置

```shell
# 新容器需要更新仓库
yum upgrade
yum update
# 安装包
yum install vim gcc gcc-c++ gdb make initscripts openssh-server openssh-clients wget svn
# 安装cmake
cd ~
wget https://github.com/Kitware/CMake/releases/download/v3.20.3/cmake-3.20.3-linux-x86_64.sh
./cmake-3.20.3-linux-x86_64.sh --prefix=/usr/local
mv /usr/local/cmake-3.20.3-linux-x86_64/ /usr/local/cmake/
# 配置cmake环境变量
echo "export PATH=\$PATH:/usr/local/cmake/bin" >> ~/.bashrc
source ~/.bashrc # 启用环境变量
# 启动ssh服务
service sshd start
# 更改root用户密码
passwd root
```

## Clion设置

### SSH配置

文件->设置->构建、执行、部署->工具链->添加->远程主机，凭据旁的设置添加服务器。

![image-20210603111732713](images/image-20210603111732713.png)

## 工具链设置

![image-20210603111816201](images/image-20210603111816201.png)

## CMake设置

![image-20210603111842236](images/image-20210603111842236.png)

下面就可以在Windows环境下进行Linux开发了。切换cmake配置还可以确认代码的平台兼容性。