# 泰森多边形

用$X$表示一个距离函数为$d$的空间（一个非空集合）。令 $K$为一个指数集合，$(P_{k})_{k\in K}$为空间$X$的一个非空子集的有序元组。对应于$P_{k}$的$R_{k}$，称沃罗诺伊原胞，或称沃罗诺伊区域，是空间$X$中所有到$P_{k}$的距离不大于到其他位置$P_j$（j≠k）的点集。或者说，如果定义$d(x,A)=\inf\{d(x,a)\,|\,a\in A\}$为点$x$和子集$A$的距离，则：

$$R_{k}=\{x\in X\,\,|\,\,d(x,P_{k})\leq d(x,P_{j})\,\,{\text{for all}}\,\,j\neq k\}$$

# 度中心性

对于具有$|V|$顶点和$|E|$边的给定图$G:=(V，E)$，顶点$v$的度中心性定义为：

$$C_{D}(v)=\deg(v)$$

假设$v*$是$G$中度中心性最高的节点。令$X:=(Y，Z)$为$|Y|$-node连接图，该图最大程度地增加了以下数量（其中$y*$是$X$中具有最高度中心度的节点）：

$$H=\sum _{{j=1}}^{{|Y|}}[C_{D}(y*)-C_{D}(y_{j})]$$

相应地，图$G$的度中心性如下：

$$C_{D}(G)={\frac {\sum _{i=1}^{|V|}[C_{D}(v*)-C_{D}(v_{i})]}{H}}$$

# 邻近中心性

对于具有$|V|$顶点和$|E|$边的给定图$G:=(V，E)$，顶点$v$的邻近中心性定义为：

$$C(x)={\frac {1}{\sum _{y}d(y,x)}}$$

其中$d(y，x)$是顶点$x$和$y$之间的距离。

# 介中心性

对于具有$|V|$顶点和$|E|$边的给定图$G:=(V，E)$，顶点$v$的介中心性定义为：

$$C_{B}(v)=\sum _{s\neq v\neq t\in V}{\frac {\sigma _{st}(v)}{\sigma _{st}}}$$

其中$\sigma_{st}$是从节点$s$到节点$t$的最短路径总数，而$\sigma_{st}(v)$是其中的最短路径通过$v$的路径总数。